---
id: ecosystem
title:  "Ecosystem"
---

## Official ZIO Libraries

These libraries are hosted in the [ZIO organization](https://github.com/zio/) on Github, and are generally maintained by core contributors to ZIO.

- [ZIO Actors](https://github.com/zio/zio-actors): A high-performance, purely-functional library for building, composing, and supervising typed actors based on ZIO
- [ZIO Akka Cluster](https://github.com/zio/zio-akka-cluster): A ZIO wrapper for Akka Cluster
- [ZIO Kafka](https://github.com/zio/zio-kafka): A Kafka client for ZIO and ZIO Streams
- [ZIO Keeper](https://github.com/zio/zio-keeper): A functional library for consistent replication of metadata across dynamic clusters
- [ZIO NIO](https://github.com/zio/zio-nio): A performant, purely-functional, low-level, and unopinionated wrapper around Java NIO functionality
- [ZIO SQS](https://github.com/zio/zio-sqs): A ZIO-powered client for AWS SQS


## Libraries with Direct ZIO Support

If you know a useful library that has direct support for ZIO, please consider [submitting a pull request](https://github.com/zio/zio/pulls) to add it to this list.

- [cakeless](https://github.com/itkpi/cakeless): Better reader monad for deeply-nested cakes
- [distage](https://github.com/7mind/izumi): Staged, transparent and debuggable runtime & compile-time Dependency Injection Framework
- [logstage](https://github.com/7mind/izumi): Automatic structural logs from Scala string interpolations
- [idealingua](https://github.com/7mind/izumi): API Definition, Data Modeling and RPC Language, optimized for fast prototyping – like gRPC, but with a human face
- [scanamo](https://github.com/scanamo/scanamo): Simpler DynamoDB access for Scala
- [sttp](https://github.com/softwaremill/sttp): The Scala HTTP client you always wanted!
- [zio-saga](https://github.com/VladKopanev/zio-saga): Purely functional transaction management with Saga pattern
- [zio-slf4j](https://github.com/NeQuissimus/zio-slf4j): Referentially transparent logging with slf4j
- [slf4zio](https://github.com/mlangc/slf4zio): Simple convenience layer on top of SLF4J for ZIO
- [zio-slick](https://github.com/rleibman/zio-slick): Bridge library between ZIO and Slick Functional Relational Mapping Library
- [zio-email](https://github.com/funcit/zio-email): Purely functional email client


## ZIO Interoperability Libraries

ZIO provides the ability to interoperate with other parts of the broader ecosystem, see [Interop](../interop/index.md) for overview.
